package com.example.pulit;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;

import android.Manifest;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;

import com.android.volley.RequestQueue;
import com.android.volley.toolbox.Volley;
import com.example.pulit.dialog.MyDialog;
import com.example.pulit.dialog.TipDialog;

import java.text.DecimalFormat;

public abstract class BaseActivity extends AppCompatActivity {
    private ScanBroadcastReceiver scanBroadcastReceiver;
    public RequestQueue mQueue;
    public MyDialog dialog;
    public DecimalFormat decimalFormat = new DecimalFormat("0.000");
    public TipDialog tipDialog;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        scanBroadcastReceiver = new ScanBroadcastReceiver();
//        mQueue = Volley.newRequestQueue(this);
                    ActivityCompat.requestPermissions(this,
                            new String[]{Manifest.permission.ACCESS_NETWORK_STATE,Manifest.permission.INTERNET},
                            100);
        dialog=new MyDialog(this);
        tipDialog=new TipDialog(this);
    }

    @Override
    protected void onResume() {
        super.onResume();

        IntentFilter intentFilter = new IntentFilter();
        intentFilter.addAction("com.qs.scancode");
        this.registerReceiver(scanBroadcastReceiver, intentFilter);
    }

    private class ScanBroadcastReceiver extends BroadcastReceiver{

        @Override
        public void onReceive(Context context, Intent intent) {
            scanInfo(intent.getExtras().getString("data"));
        }
    }
    public abstract void scanInfo(String info);

    public void sanCode() {
        //模拟触发扫描按键，发出广播，开始扫描
        Intent intentBroadcast = new Intent();
        intentBroadcast.setAction("hbyapi.intent.key_scan_down");
        sendBroadcast(intentBroadcast);
    }


    @Override
    protected void onDestroy() {
        // TODO Auto-generated method stub
        //退出时候注销广播接收器
        unregisterReceiver(scanBroadcastReceiver);
        super.onDestroy();
    }
}