package com.example.pulit;

import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import com.alibaba.fastjson2.JSONObject;
import com.example.pulit.util.MyOkGoCallback;
import com.example.pulit.util.Resust;
import com.example.pulit.util.SharedPreferencesUtils;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

public class LtActivity extends BaseActivity {

    @BindView(R.id.lt_code)
    TextView ltCode;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_lt);
        ButterKnife.bind(this);
    }

    @Override
    public void scanInfo(String info) {
        ltCode.setText(info);
        dialog.show();
        OkGo.<Resust>get("http://" + SharedPreferencesUtils.getstring("ip", null) + "/api/xl_material/MaterialVerification")
                .params("barCode", info)
                .execute(new MyOkGoCallback() {
                    @Override
                    public void onSuccess(Response<Resust> response) {
                        super.onSuccess(response);
                        dialog.dismiss();

                        Resust body = response.body();
                        tipDialog.showMsg(body.isSuccess(), body.getMsg());

                    }

                    @Override
                    public void onError(Response<Resust> response) {
                        super.onError(response);
                        dialog.dismiss();
                        Toast.makeText(LtActivity.this, "网络请求失败", Toast.LENGTH_SHORT).show();
                    }
                });
    }

    @OnClick({R.id.lt_title_back, R.id.lt_scan})
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.lt_title_back:
                this.finish();
                break;
            case R.id.lt_scan:
                super.sanCode();
                break;

        }
    }
}