package com.example.pulit;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import com.example.pulit.dialog.SettingIPDialog;
import com.example.pulit.util.SharedPreferencesUtils;

import butterknife.ButterKnife;
import butterknife.OnClick;

public class MainActivity extends AppCompatActivity {
    private SettingIPDialog textDialog;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        ButterKnife.bind(this);
        textDialog = new SettingIPDialog(this);
        String ip = SharedPreferencesUtils.getstring("ip", null);
        if (ip == null || ip.isEmpty()) {
            Toast.makeText(this, "先设置ip", Toast.LENGTH_SHORT).show();
            textDialog.show();
        }
    }


    @OnClick({R.id.home_xl_b, R.id.home_xl_t, R.id.home_xl_z, R.id.home_rj_c, R.id.home_rj_t,
            R.id.home_setting, R.id.home_lt, R.id.home_back, R.id.home_plan})
    public void onClick(View view) {
        Intent intent = null;
        switch (view.getId()) {
            case R.id.home_xl_b:
                intent = new Intent(this, X2Activity.class);
                break;
            case R.id.home_xl_t:
                intent = new Intent(this, X1Activity.class);
                break;
            case R.id.home_xl_z:
                intent = new Intent(this, X3Activity.class);
                break;
            case R.id.home_rj_c:
                intent = new Intent(this, SolventActivity.class);
                break;
            case R.id.home_rj_t:
                intent = new Intent(this, So2Activity.class);
                break;
            case R.id.home_plan:
                intent = new Intent(this, ZBActivity.class);
                break;
            case R.id.home_setting:
                textDialog.setIpAddress(SharedPreferencesUtils.getstring("ip", null));
                textDialog.show();
                break;
            case R.id.home_lt:
                intent = new Intent(this, LtActivity.class);
                break;

            case R.id.home_back:
                finish();
                break;
        }
        if (intent != null) {
            startActivity(intent);
        }
    }
}