package com.example.pulit;

import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Spinner;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.example.pulit.adapter.PlanAdapter;
import com.example.pulit.entity.AxPlan;
import com.example.pulit.util.MyOkGoCallback;
import com.example.pulit.util.Resust;
import com.example.pulit.util.SharedPreferencesUtils;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

public class PlanActivity extends BaseActivity {

    @BindView(R.id.plan_type)
    Spinner planType;
    @BindView(R.id.plan_recycler)
    RecyclerView planRecycler;
    private PlanAdapter adapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_plan);
        ButterKnife.bind(this);
        planRecycler.setLayoutManager(new LinearLayoutManager(this));
        adapter = new PlanAdapter(this);


    }

    @Override
    public void scanInfo(String info) {

    }

    @OnClick({R.id.info_title_back, R.id.plan_select})
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.info_title_back:
                finish();
                break;
            case R.id.plan_select:
                String type = planType.getSelectedItem().toString();
                String url = null;
                if (type.equals("小料")) {
                    url = "/api/xl_material/GetXlPlanInfo";
                } else {
                    url = "/api/Solvent/GetSolventPlanInfo";
                }
                dialog.show();
                OkGo.<Resust>get("http://"+SharedPreferencesUtils.getstring("ip", null)+url).execute(new MyOkGoCallback(){
                    @Override
                    public void onSuccess(Response<Resust> response) {
                        super.onSuccess(response);
                        dialog.dismiss();
                        List<AxPlan> list= JSON.parseArray(response.body().getData(),AxPlan.class);
                        Log.e("TAG", "onSuccess:" + list.toString());
                        adapter.setList(list);
                        planRecycler.setAdapter(adapter);
                    }

                    @Override
                    public void onError(Response<Resust> response) {
                        super.onError(response);
                        dialog.dismiss();
                        Toast.makeText(PlanActivity.this, "网络连接错误", Toast.LENGTH_SHORT).show();
                    }
                });
                break;
        }
    }
}