package com.example.pulit;

import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import com.alibaba.fastjson2.JSONObject;
import com.example.pulit.entity.PlanView;
import com.example.pulit.util.MyOkGoCallback;
import com.example.pulit.util.Resust;
import com.example.pulit.util.SharedPreferencesUtils;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import okhttp3.MediaType;
import okhttp3.RequestBody;

public class So2Activity extends BaseActivity {

    @BindView(R.id.solvent2_code)
    TextView solvent2Code;
    @BindView(R.id.solvent2_goods_code)
    TextView solvent2GoodsCode;
    private boolean sanType;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_so2);
        ButterKnife.bind(this);
        sanType = true;
    }

    private String Plan_Id;
    private String PumpBarCode;

    @Override
    public void scanInfo(String info) {
        if (sanType) {
            solvent2Code.setText(info);
            OkGo.<Resust>get("http://" + SharedPreferencesUtils.getstring("ip", null) + "/api/Solvent/GetByPumpInfo")
                    .params("code", info)
                    .execute(new MyOkGoCallback() {
                        @Override
                        public void onSuccess(Response<Resust> response) {
                            super.onSuccess(response);
                            dialog.dismiss();
                            if (response.body().isSuccess()) {
                                JSONObject dateObj = response.body().getDateObj();
                                Plan_Id = dateObj.getString("Plan_Id");
                                PumpBarCode = dateObj.getString("PumpBarCode");
                                Toast.makeText(So2Activity.this, "查询成功", Toast.LENGTH_SHORT).show();
                                sanType = false;
                            } else {
                                Toast.makeText(So2Activity.this, response.body().getMsg(), Toast.LENGTH_SHORT).show();
                            }
                        }

                        @Override
                        public void onError(Response<Resust> response) {
                            super.onError(response);
                            dialog.dismiss();
                            Toast.makeText(So2Activity.this, "网络请求失败", Toast.LENGTH_SHORT).show();
                        }
                    });
        } else {
            solvent2GoodsCode.setText(info);
        }
    }

    @OnClick({R.id.info_title_back, R.id.solvent2_scan, R.id.solvent2_submit})
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.info_title_back:
                finish();
                break;
            case R.id.solvent2_scan:
                sanCode();
                break;
            case R.id.solvent2_submit:
                if (Plan_Id == null || Plan_Id.isEmpty()) return;
                dialog.show();
                OkGo.<Resust>get("http://" + SharedPreferencesUtils.getstring("ip", null) + "/api/Solvent/ExecState")
                        .params("planId",Plan_Id)
                        .params("pumpCode",PumpBarCode)
                        .params("cylinderCode",solvent2GoodsCode.getText().toString())
                        .execute(new MyOkGoCallback() {
                            @Override
                            public void onSuccess(Response<Resust> response) {
                                super.onSuccess(response);
                                dialog.dismiss();
                                Toast.makeText(So2Activity.this, response.body().getMsg(), Toast.LENGTH_SHORT).show();
                                if (response.body().isSuccess()) {
                                    finish();
                                }
                            }

                            @Override
                            public void onError(Response<Resust> response) {
                                super.onError(response);
                                dialog.dismiss();
                                Toast.makeText(So2Activity.this, "网络请求失败", Toast.LENGTH_SHORT).show();
                            }
                        });
                break;
        }
    }
}