package com.example.pulit;

import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.alibaba.fastjson2.JSONObject;
import com.example.pulit.entity.PlanView;
import com.example.pulit.util.MyOkGoCallback;
import com.example.pulit.util.Resust;
import com.example.pulit.util.SharedPreferencesUtils;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.callback.StringCallback;
import com.lzy.okgo.model.Response;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import okhttp3.MediaType;
import okhttp3.RequestBody;

public class SolventActivity extends BaseActivity {

    @BindView(R.id.solvent_code)
    TextView solventCode;
    @BindView(R.id.solvent_goods_code)
    TextView solventGoodsCode;
    @BindView(R.id.solvent_goodsName)
    TextView solventGoodsName;
    @BindView(R.id.s2gion)
    LinearLayout s2gion;
    @BindView(R.id.solvent_db)
    Spinner solventDb;
    @BindView(R.id.solvent_goodslv)
    TextView solventGoodslv;
    @BindView(R.id.solvent_goodslv_state)
    LinearLayout solventGoodslvState;
    private int sanType;
    private boolean exist;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_solvent);
        ButterKnife.bind(this);
        sanType = 0;

    }

    private PlanView planView;

    @Override
    public void scanInfo(String info) {

        switch (sanType) {
            case 0:
                dialog.show();
                solventCode.setText(info);
                String dbName = solventDb.getSelectedItem().toString();
                selectSup(info, dbName);
                break;
            case 1:
                try {
                    checkGoods(info);
                } catch (Exception e) {
                    e.printStackTrace();
                    Toast.makeText(this, "条码格式错误", Toast.LENGTH_SHORT).show();
                }
                break;
            case 2:
                solventGoodslv.setText(info.replace("%", "").trim());
                break;

        }


    }

    @OnClick({R.id.info_title_back, R.id.solvent_scan, R.id.solvent_submit})
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.info_title_back:
                finish();
                break;
            case R.id.solvent_scan:
                super.sanCode();
                break;
            case R.id.solvent_submit:
                if (planView == null) return;
                String string1 = solventGoodslv.getText().toString();
                if (exist && string1.isEmpty()) {
                    Toast.makeText(this, "必须扫描固含率", Toast.LENGTH_SHORT).show();
                    return;
                }
                String dbaname = solventDb.getSelectedItem().toString();
                String string = solventCode.getText().toString();

                dialog.show();
                planView.setWeighbridge(dbaname);
                planView.setCylinderBarCode(string);
                planView.setRate(string1.isEmpty() ? "0" : string1);
                List<String> list = new ArrayList<>(1);
                list.add(solventGoodsCode.getText().toString().trim());
                planView.setBarCodeList(list);
                RequestBody requestBody = RequestBody.create(MediaType.parse("application/json;"),
                        JSONObject.toJSONString(planView));
                OkGo.<Resust>post("http://" + SharedPreferencesUtils.getstring("ip", null) + "/api/Solvent/ExecPlcState")
                        .upRequestBody(requestBody)
                        .execute(new MyOkGoCallback() {
                            @Override
                            public void onSuccess(Response<Resust> response) {
                                super.onSuccess(response);
                                dialog.dismiss();
                                Toast.makeText(SolventActivity.this, response.body().getMsg(), Toast.LENGTH_SHORT).show();
                                if (response.body().isSuccess()) {
                                    sanType = 0;
                                    solventCode.setText(null);
                                    solventGoodsCode.setText(null);
                                    planView = null;
                                    solventGoodsName.setText(null);
                                    solventGoodslv.setText(null);
                                    solventGoodslvState.setVisibility(View.GONE);

                                }
                            }

                            @Override
                            public void onError(Response<Resust> response) {
                                super.onError(response);
                                dialog.dismiss();
                                Toast.makeText(SolventActivity.this, "网络请求失败", Toast.LENGTH_SHORT).show();
                            }
                        });
                break;
        }
    }

    private void selectSup(String info, String dbName) {
        OkGo.<String>get("http://" + SharedPreferencesUtils.getstring("ip", null) + "/api/Solvent/GetByCylinderInfo")
                .params("code", info)
                .params("weighbridge", dbName)
                .execute(new StringCallback() {
                    @Override
                    public void onSuccess(Response<String> response) {
                        dialog.dismiss();
                        String body = response.body();
                        Resust resust = JSONObject.parseObject(response.body(), Resust.class);
                        if (resust.isSuccess()) {
                            String substring = body.substring(body.indexOf(":{") + 1, body.length() - 1);
                            planView = JSONObject.parseObject(substring, PlanView.class);
                            Log.e("TAG", "onSuccess:" + planView.toString());
                            exist = planView.isExist();
                            if (exist) {
                                solventGoodslvState.setVisibility(View.VISIBLE);

                            }
                            Toast.makeText(SolventActivity.this, "查询成功", Toast.LENGTH_SHORT).show();
                            sanType = 1;//扫描物料
                        } else {
                            Toast.makeText(SolventActivity.this, resust.getMsg(), Toast.LENGTH_SHORT).show();
                        }
                    }

                    @Override
                    public void onError(Response<String> response) {
                        super.onError(response);
                        dialog.dismiss();
                        Toast.makeText(SolventActivity.this, "网络连接错误", Toast.LENGTH_SHORT).show();
                    }
                });
    }

    private void checkGoods(String scanInfo) {
        solventGoodsCode.setText(scanInfo);
        //物料编码
        String goodsCode = scanInfo.substring(0, scanInfo.indexOf("-"));
        Log.e("TAG", "scanInfo:" + goodsCode);
        planView.setCode(goodsCode);
        //品名
        int index = scanInfo.indexOf("-", scanInfo.indexOf("-", scanInfo.indexOf("-") + 1) + 1) + 1;
        int endIndex = scanInfo.indexOf("|");
        String goodsName = scanInfo.substring(index, endIndex);
        Log.e("TAG", "scanInfo:" + goodsName);
        planView.setMaterialName(goodsName);
        solventGoodsName.setText(goodsName);
        //重量
        String format = decimalFormat.format(
                Double.parseDouble(scanInfo.substring(scanInfo.indexOf("|") + 1, scanInfo.indexOf("kg"))));
        double weight = Double.parseDouble(format);
        planView.setMaterialWeight(weight);
        planView.setWholeMaterial(scanInfo);
        //称量只验证类型 也就是条码
        if (planView.getMaterial_code().equals(goodsCode)) {
            planView.setState(1);
            tipDialog.showState(true);
            sanType = exist ? 2 : 1;

        } else {
            planView.setState(0);
            tipDialog.showState(false);
        }
    }
}