package com.example.pulit;

import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ListPopupWindow;
import android.widget.TextView;
import android.widget.Toast;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONArray;
import com.alibaba.fastjson2.JSONObject;
import com.example.pulit.adapter.ItemAdapter;
import com.example.pulit.entity.Item;
import com.example.pulit.entity.MaterialView;
import com.example.pulit.entity.X1;
import com.example.pulit.entity.X1SubmintChild;
import com.example.pulit.entity.X1Submit;
import com.example.pulit.util.MyOkGoCallback;
import com.example.pulit.util.Resust;
import com.example.pulit.util.SharedPreferencesUtils;
import com.google.gson.Gson;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import okhttp3.MediaType;
import okhttp3.RequestBody;

public class X1Activity extends BaseActivity {

    @BindView(R.id.x1_code)
    TextView x1Code;
    @BindView(R.id.x1_recycler_view)
    RecyclerView x1RecyclerView;
    @BindView(R.id.x1_tong)
    TextView x1Tong;
    @BindView(R.id.x1_goods_code)
    TextView x1GoodsCode;
    @BindView(R.id.x1_goods_Weight)
    TextView x1GoodsWeight;
    @BindView(R.id.x1_code1)
    LinearLayout x1Code1;
    @BindView(R.id.x1_plan_code)
    TextView x1PlanCode;
    @BindView(R.id.x1_scan)
    Button x1Scan;
    @BindView(R.id.x1_submit)
    Button x1Submit;
    @BindView(R.id.x1_submit2)
    Button x1Submit2;
    private boolean scanStates;
    private List<Item> items;
    private ItemAdapter adapter;
    private ListPopupWindow lpw;
    private List<String> planList;
    private String planId;
    private List<String> serialList;//整包流水号

    //    提交字段
    private X1Submit entrySubmit;
    private List<X1SubmintChild> submintChildList;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_x1);
        ButterKnife.bind(this);
        serialList = new ArrayList<>();//初始化流水号
        entrySubmit = new X1Submit();
        scanStates = true;
        x1RecyclerView.setLayoutManager(new LinearLayoutManager(this));
        adapter = new ItemAdapter(this);
        lpw = new ListPopupWindow(this);
        lpw.setAnchorView(x1PlanCode);
        lpw.setOnItemClickListener((adapterView, view, i, l) -> {
            planId = planList.get(i);
            selectPlanByID(x1Code.getText().toString(), planId);
            submintChildList = new ArrayList<>();
            lpw.dismiss();
        });
    }

    @Override
    public void scanInfo(String info) {
        Log.e("TAG", "scanInfo:" + info);
        if (scanStates) {
            x1Code.setText(info);
            dialog.show();
            //反应釜查询
            getF(info);
        } else {
            x1Tong.setText(info);
            if (info.contains("kg")) {
                try {
                    //整包 截取 物料编码  000524-20230805-0001-CF-130|25kg
                    String goodsCode = info.substring(0, info.indexOf("-"));
                    //格式化重量
                    String stringFormatWeight = decimalFormat.format(
                            Double.parseDouble(info.substring(info.indexOf("|") + 1, info.indexOf("kg"))));
                    double goodsWeight = Double.parseDouble(stringFormatWeight);
                    String name1 = info.substring(info.indexOf("-") + 1, info.indexOf("|"));//20230805-0001-CF-130
                    String name2 = name1.substring(name1.indexOf("-") + 1, name1.length());
                    String name3 = name2.substring(name2.indexOf("-") + 1, name2.length());//物料名称
                    String lxh = name2.substring(0, name2.indexOf("-"));
                    String plancode = x1PlanCode.getText().toString();
                    String zh = plancode + goodsCode + lxh;//流水号组合
                    Log.e("TAG", "流水号组合:" + zh);
                    if (serialList.contains(zh)) {
                        tipDialog.showMsg(false, "相同流水号物料已确认");
                        return;
                    }
                    checkItem(goodsCode, goodsWeight, "整包", "", name3, zh);
                } catch (Exception e) {
                    e.printStackTrace();
                    Toast.makeText(this, "整包条码错误", Toast.LENGTH_SHORT).show();
                }

            } else {
                //散装、查询接口
                selectGoods(info);
            }

        }


    }


    @OnClick({R.id.info_title_back, R.id.x1_scan, R.id.x1_submit, R.id.x1_submit2, R.id.x1_plan_code})
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.info_title_back:
                finish();
                break;
            case R.id.x1_scan:
                super.sanCode();
                break;
            case R.id.x1_submit:
                if (entrySubmit == null) return;
                for (Item item : items) {
                    if (!item.isState()) {
                        Toast.makeText(this, "还有物料未验证", Toast.LENGTH_SHORT).show();
                        return;
                    }
                }
                submit(entrySubmit, 1);
                break;
            case R.id.x1_submit2:
                if (entrySubmit == null) return;
                submit(entrySubmit, 0);
                break;
            case R.id.x1_plan_code:
                lpw.show();
                break;
        }
    }


    //提交
    private void submit(X1Submit entrySubmit, int state) {
        dialog.show();
        entrySubmit.setkCode(x1Code.getText().toString());
        entrySubmit.setState(state);
        entrySubmit.setPlanId(planId);
        entrySubmit.setChild(submintChildList);
        RequestBody requestBody = RequestBody.create(MediaType.parse("application/json;"),
                JSONObject.toJSONString(entrySubmit));
        OkGo.<Resust>post("http://" + SharedPreferencesUtils.getstring("ip", null) + "/api/Warehouse/ExecPlcState")
                .upRequestBody(requestBody)
                .execute(new MyOkGoCallback() {
                    @Override
                    public void onSuccess(Response<Resust> response) {
                        super.onSuccess(response);
                        dialog.dismiss();
                        Toast.makeText(X1Activity.this, response.body().getMsg(), Toast.LENGTH_SHORT).show();
                        if (response.body().isSuccess()) {
                            if (state == 1) {
                                tipDialog.showMsg(true, "提交成功");
                                return;
                            }
                            finish();
                        }
                    }

                    @Override
                    public void onError(Response<Resust> response) {
                        super.onError(response);
                        dialog.dismiss();
                    }
                });
    }

    //查询 釜
    private void getF(String info) {
        OkGo.<Resust>get("http://" + SharedPreferencesUtils.getstring("ip", null) + "/api/Warehouse/GetWarehousePlan")
                .params("code", info)
                .execute(new MyOkGoCallback() {
                             @Override
                             public void onSuccess(Response<Resust> response) {
                                 super.onSuccess(response);
                                 dialog.dismiss();
                                 if (response.body().isSuccess()) {
                                     planList = JSON.parseArray(response.body().getData(), String.class);
                                     lpw.setAdapter(new ArrayAdapter(X1Activity.this,
                                             R.layout.support_simple_spinner_dropdown_item,
                                             planList));
                                     tipDialog.showMsg(true, "查询成功,请选择计划");
                                 } else {
                                     Toast.makeText(X1Activity.this, "请求失败，反应釜条码不正确", Toast.LENGTH_SHORT).show();
                                 }
                             }

                             @Override
                             public void onError(Response<Resust> response) {
                                 super.onError(response);
                                 dialog.dismiss();
                                 Toast.makeText(X1Activity.this, "网络请求失败", Toast.LENGTH_SHORT).show();
                             }
                         }
                );
    }

    //查询计划中的物料
    private void selectPlanByID(String code, String planID) {
        x1PlanCode.setText(planID);
        OkGo.<Resust>get("http://" + SharedPreferencesUtils.getstring("ip", null) + "/api/Warehouse/GetByCode")
                .params("code", code)
                .params("planId", planID)
                .execute(new MyOkGoCallback() {
                             @Override
                             public void onSuccess(Response<Resust> response) {
                                 super.onSuccess(response);
                                 dialog.dismiss();
                                 if (response.body().isSuccess()) {
                                     X1 x1 = JSONObject.parseObject(response.body().getData(), X1.class);
                                     entrySubmit.setStation(x1.getID());//提交的字段
                                     items = x1.getChildren();
                                     adapter.setList(items);
                                     x1RecyclerView.setAdapter(adapter);
                                     scanStates = false;//扫描
                                     x1Tong.setText(null);
                                     x1GoodsCode.setText(null);
                                     x1GoodsWeight.setText(null);

                                 } else {
                                     Toast.makeText(X1Activity.this, "请求失败，计划条码不正确", Toast.LENGTH_SHORT).show();
                                 }
                             }

                             @Override
                             public void onError(Response<Resust> response) {
                                 super.onError(response);
                                 dialog.dismiss();
                                 Toast.makeText(X1Activity.this, "网络请求失败", Toast.LENGTH_SHORT).show();
                             }
                         }
                );
    }

    //查询散装
    private void selectGoods(String info) {
        OkGo.<Resust>get("http://" + SharedPreferencesUtils.getstring("ip", null) + "/api/Warehouse/GetByBarrelInfo")
                .params("kettleBarCode", x1Code.getText().toString())
                .params("planId", planId)
                .params("code", info)
                .execute(new MyOkGoCallback() {
                    @Override
                    public void onSuccess(Response<Resust> response) {
                        super.onSuccess(response);
                        if (response.body().isSuccess()) {
                            JSONObject jsonObject = JSONObject.parseObject(response.body().getData());

                            List<MaterialView> list = JSONArray.parseArray(jsonObject.get("child").toString(), MaterialView.class);

                            String tipTag = "";

                            for (MaterialView materialView : list) {
                                if (materialView.getMatchOrNot() == 0) {
                                    tipTag += materialView.getMaterialName() + "(" + materialView.getMaterialBarCode() + ")";
                                }
                            }
                            if (!tipTag.equals("")) {
                                tipDialog.showMsg(false, tipTag + " 不合格");
                                return;
                            }
                            for (MaterialView materialView : list) {
                                double goodsWeight = materialView.getWeight();
                                String goodsCode = materialView.getMaterialBarCode();
                                checkItem(goodsCode, goodsWeight, "散装", info, materialView.getMaterialName(), null);
                            }

                        } else {
                            Toast.makeText(X1Activity.this, "查询失败，条码不正确", Toast.LENGTH_SHORT).show();
                            x1GoodsCode.setText(null);
                            x1GoodsWeight.setText(null);
                        }
                    }

                    @Override
                    public void onError(Response<Resust> response) {
                        super.onError(response);
                        dialog.dismiss();
                    }
                });
    }

    /**
     * 比对
     *
     * @param goodsCode   扫描码
     * @param goodsWeight 重量
     * @param matType     整包、散装
     * @param info        散装码
     * @param t           物料名称
     * @param zbCode      整包流水号
     */
    private void checkItem(String goodsCode, double goodsWeight, String matType, String info, String t, String zbCode) {
        x1GoodsCode.setText(goodsCode);
        x1GoodsWeight.setText(goodsWeight + "");
        X1SubmintChild entrySubmitcChild = new X1SubmintChild();
        int index = -1;//目标
        A:for (int i = 0; i < items.size(); i++) {
            Item indexItem = items.get(i);
            if (!indexItem.isState() && indexItem.getMaterial_Code().equals(goodsCode)) {
                double selectWeight = indexItem.getSetWeight();//列表中的重量
                double errorWeight = indexItem.getSetError();//误差 整包后台应该传0
                Log.e("TAG", "checkItem:" + selectWeight + "," + errorWeight);
                if (selectWeight - errorWeight <= goodsWeight && selectWeight + errorWeight >= goodsWeight) {
                    index = i;
                    break A;
                }
            }
        }

        //验证
        if (index != -1) {
            Item selectItem = items.get(index);
            entrySubmitcChild.setMatType(matType);
            entrySubmitcChild.setMatCode(goodsCode);
            entrySubmitcChild.setMatName(t);
            entrySubmitcChild.setMatWeight(goodsWeight);
            entrySubmitcChild.setWholePackage("string");
            entrySubmitcChild.setBarrelCode(info);
            submintChildList.add(entrySubmitcChild);
            tipDialog.showState(true);
            selectItem.setState(true);
            adapter.notifyDataSetChanged();
            if (matType.equals("整包")) {
                serialList.add(zbCode);
            }
        } else {
            tipDialog.showState(false);
        }


    }
}