package com.example.pulit;

import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import com.alibaba.fastjson2.JSONObject;
import com.example.pulit.util.MyOkGoCallback;
import com.example.pulit.util.Resust;
import com.example.pulit.util.SharedPreferencesUtils;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import okhttp3.MediaType;
import okhttp3.RequestBody;

public class X2Activity extends BaseActivity {

    @BindView(R.id.x2_code)
    TextView x2Code;
    @BindView(R.id.x2_plan_code)
    TextView x2PlanCode;
    @BindView(R.id.x2_goods)
    TextView x2Goods;
    @BindView(R.id.x2_goods_code)
    TextView x2GoodsCode;
    @BindView(R.id.x2_plan_name)
    TextView x2PlanName;
    @BindView(R.id.x2_goods_name)
    TextView x2GoodsName;
    private boolean sanType;
    private int state = 0;
    private int Bin_Serial;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_x2);
        ButterKnife.bind(this);
        sanType = true;
    }

    //1A000001、000524
    private String weight;
    private String goodsCode;

    @Override
    public void scanInfo(String info) {
        if (sanType) {
            x2Code.setText(info);
            selectSup(info);
        } else {
            x2Goods.setText(info);
//            if (info.contains("kg")) {
            try {
                //整包 截取
                goodsCode = info.substring(0, info.indexOf("-"));
                checkItem(goodsCode);
                x2GoodsCode.setText(goodsCode);
                int index = info.indexOf("-", info.indexOf("-", info.indexOf("-") + 1) + 1) + 1;
                int endIndex = info.indexOf("|");
                String goodsName = info.substring(index, endIndex);
                x2GoodsName.setText(goodsName);
                weight = info.substring(endIndex + 1, info.indexOf("kg"));
                Log.e("TAG", "截取的重量:" + weight);
            } catch (Exception e) {
                e.printStackTrace();
                Toast.makeText(this, "条码错误", Toast.LENGTH_SHORT).show();
            }

//            } else {
//                selectGoodsInfo(info);
//
//            }
        }


    }

    private void checkItem(String goodsCode) {
        String planCode = x2PlanCode.getText().toString();
        if (planCode.equals(goodsCode)) {
            tipDialog.showState(true);
            state = 1;
        } else {
            tipDialog.showState(false);
            state = 2;
        }

    }


    @OnClick({R.id.info_title_back, R.id.x2_scan, R.id.x2_submit})
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.info_title_back:
                finish();
                break;
            case R.id.x2_scan:
                super.sanCode();
                break;
            case R.id.x2_submit:
                if (state == 0) return;
                dialog.show();

                OkGo.<Resust>get("http://" + SharedPreferencesUtils.getstring("ip", null) + "/api/xl_material/ExecPlcCode")
                        .params("code", Bin_Serial)
                        .params("state", state)
                        .params("materialCode", goodsCode)
                        .params("weight", weight)
                        .params("barCode", x2Goods.getText().toString().trim())
                        .execute(new MyOkGoCallback() {
                            @Override
                            public void onSuccess(Response<Resust> response) {
                                super.onSuccess(response);
                                dialog.dismiss();
                                Toast.makeText(X2Activity.this, response.body().getMsg(), Toast.LENGTH_SHORT).show();
                                if (response.body().isSuccess()) {
                                    finish();
                                }
                            }

                            @Override
                            public void onError(Response<Resust> response) {
                                super.onError(response);
                                dialog.dismiss();
                            }
                        });
                break;
        }
    }

    private void selectSup(String info) {
        dialog.show();
        OkGo.<Resust>get("http://" + SharedPreferencesUtils.getstring("ip", null) + "/api/xl_material/GetByBinCode")
                .params("code", info)
                .execute(new MyOkGoCallback() {
                             @Override
                             public void onSuccess(Response<Resust> response) {
                                 super.onSuccess(response);
                                 dialog.dismiss();
                                 if (response.body().isSuccess()) {
                                     JSONObject obj = response.body().getDateObj();
                                     x2PlanCode.setText(obj.getString("Material_code"));
                                     Bin_Serial = obj.getInteger("Bin_Serial");
                                     x2PlanName.setText(obj.getString("Material_Name"));
                                     sanType = false;
                                 } else {
                                     Toast.makeText(X2Activity.this, "请求失败，条码不正确", Toast.LENGTH_SHORT).show();
                                     x2PlanCode.setText(null);
                                     x2PlanName.setText(null);
                                 }
                             }

                             @Override
                             public void onError(Response<Resust> response) {
                                 super.onError(response);
                                 dialog.dismiss();
                                 Toast.makeText(X2Activity.this, "网络请求失败", Toast.LENGTH_SHORT).show();
                             }
                         }
                );

    }


/*    private void selectGoodsInfo(String info) {
        dialog.show();
        OkGo.<Resust>get("http://" + SharedPreferencesUtils.getstring("ip", null) + "/api/xl_material/GetByMaterialCode")
                .params("code", info)
                .execute(new MyOkGoCallback() {
                             @Override
                             public void onSuccess(Response<Resust> response) {
                                 super.onSuccess(response);
                                 dialog.dismiss();
                                 if (response.body().isSuccess()) {
                                     JSONObject obj = response.body().getDateObj();
                                     String material_code = obj.getString("Material_code");
                                     x2GoodsCode.setText(material_code);
                                     x2GoodsName.setText(obj.getString("Material_name"));
                                     checkItem(material_code);
                                 } else {
                                     Toast.makeText(X2Activity.this, "请求失败，条码不正确", Toast.LENGTH_SHORT).show();
                                     x2GoodsCode.setText(null);
                                     x2GoodsCode.setText(null);
                                 }
                             }

                             @Override
                             public void onError(Response<Resust> response) {
                                 super.onError(response);
                                 dialog.dismiss();
                                 Toast.makeText(X2Activity.this, "网络请求失败", Toast.LENGTH_SHORT).show();
                             }
                         }
                );

    }*/


}