package com.example.pulit;

import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import com.alibaba.fastjson2.JSONObject;
import com.example.pulit.util.MyOkGoCallback;
import com.example.pulit.util.Resust;
import com.example.pulit.util.SharedPreferencesUtils;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import okhttp3.MediaType;
import okhttp3.RequestBody;

public class X3Activity extends BaseActivity {

    @BindView(R.id.x3_code)
    TextView x3Code;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_x3);
        ButterKnife.bind(this);
    }

    @Override
    public void scanInfo(String info) {
        x3Code.setText(info);
        Log.e("TAG", "scanInfo:" + info);
        dialog.show();
        OkGo.<Resust>get("http://" + SharedPreferencesUtils.getstring("ip", null) + "/api/xl_material/BindBarrel")
                .params("code",info)
                .execute(new MyOkGoCallback() {
                    @Override
                    public void onSuccess(Response<Resust> response) {
                        super.onSuccess(response);
                        dialog.dismiss();
                        Resust body = response.body();
                        boolean b= body.isSuccess();
                        tipDialog.showMsg(b,body.getMsg());
                    }

                    @Override
                    public void onError(Response<Resust> response) {
                        super.onError(response);
                        dialog.dismiss();
                        Toast.makeText(X3Activity.this, "网络请求失败", Toast.LENGTH_SHORT).show();
                    }
                });
    }

    @OnClick({R.id.info_title_back, R.id.x3_scan})
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.info_title_back:
                finish();
                break;
            case R.id.x3_scan:
                super.sanCode();
                break;
        }
    }
}