package com.example.pulit;

import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.alibaba.fastjson2.JSONObject;
import com.example.pulit.entity.PlanView;
import com.example.pulit.util.MyOkGoCallback;
import com.example.pulit.util.Resust;
import com.example.pulit.util.SharedPreferencesUtils;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.callback.StringCallback;
import com.lzy.okgo.model.Response;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import okhttp3.MediaType;
import okhttp3.RequestBody;

public class ZBActivity extends BaseActivity {


    @BindView(R.id.zb_db)
    Spinner zbDb;
    @BindView(R.id.zb_goods_code)
    TextView zbGoodsCode;
    @BindView(R.id.zb_goodsName)
    TextView zbGoodsName;
    private int sanType;
    private boolean exist;
    private String dbCode = null;
    private String findGoodesCode = null;
    List<String> stringList;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_zb);
        ButterKnife.bind(this);
        sanType = 0;
        stringList=new ArrayList<>();

    }

    private PlanView planView;

    @Override
    public void scanInfo(String info) {

        try {
            String dbaname = zbDb.getSelectedItem().toString();
            if (findGoodesCode == null || dbCode == null || !dbCode.equals(dbaname)) {
                dialog.show();
                OkGo.<Resust>get("http://" + SharedPreferencesUtils.getstring("ip", null) + "/api/Solvent/GetByZbCode")
                        .params("code", info)
                        .params("weighbridge", dbaname)
                        .execute(new MyOkGoCallback() {
                            @Override
                            public void onSuccess(Response<Resust> response) {
                                super.onSuccess(response);
                                dialog.dismiss();
                                Resust body = response.body();
                                if (body.getStatus() == 200) {
                                    JSONObject dateObj = body.getDateObj();
                                    findGoodesCode = dateObj.get("Material_code").toString();
                                    dbCode = dbaname;
                                    Log.e("TAG", "查询出的物料:" + findGoodesCode);

                                    checkGoods(info);

                                } else {
                                    tipDialog.showMsg(false, body.getMsg());
                                    findGoodesCode = null;
                                    dbCode = null;
                                }

                            }

                            @Override
                            public void onError(Response<Resust> response) {
                                super.onError(response);
                                dialog.dismiss();
                                Toast.makeText(ZBActivity.this, "网络连接错误", Toast.LENGTH_SHORT).show();
                                findGoodesCode = null;
                                dbCode = null;
                            }
                        });
            } else {

                checkGoods(info);

            }


        } catch (Exception e) {
            e.printStackTrace();
            Toast.makeText(this, "条码格式错误", Toast.LENGTH_SHORT).show();
        }
    }

    @OnClick({R.id.info_title_back, R.id.zb_scan, R.id.zb_submit})
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.info_title_back:
                finish();
                break;
            case R.id.zb_scan:
                super.sanCode();
                break;
            case R.id.zb_submit:
                if (planView == null) return;
                String dbaname = zbDb.getSelectedItem().toString();
                dialog.show();
                planView.setWeighbridge(dbaname);
                planView.setCylinderBarCode("00000000");
                planView.setRate("0");
                planView.setBarCodeList(stringList);
                RequestBody requestBody = RequestBody.create(MediaType.parse("application/json;"),
                        JSONObject.toJSONString(planView));
                OkGo.<Resust>post("http://" + SharedPreferencesUtils.getstring("ip", null) + "/api/Solvent/ExecPlcState")
                        .upRequestBody(requestBody)
                        .execute(new MyOkGoCallback() {
                            @Override
                            public void onSuccess(Response<Resust> response) {
                                super.onSuccess(response);
                                dialog.dismiss();
                                Toast.makeText(ZBActivity.this, response.body().getMsg(), Toast.LENGTH_SHORT).show();
                                if (response.body().isSuccess()) {
                                    sanType = 0;
                                    zbGoodsCode.setText(null);
                                    planView = null;
                                    zbGoodsName.setText(null);
                                    stringList.clear();

                                }
                            }




                            @Override
                            public void onError(Response<Resust> response) {
                                super.onError(response);
                                dialog.dismiss();
                                Toast.makeText(ZBActivity.this, "网络请求失败", Toast.LENGTH_SHORT).show();
                            }
                        });
                break;
        }
    }


    private void checkGoods(String scanInfo) {
        planView = new PlanView();
        zbGoodsCode.setText(scanInfo);
        //物料编码
        String goodsCode = scanInfo.substring(0, scanInfo.indexOf("-"));
        Log.e("TAG", "scanInfo:" + goodsCode);
        planView.setCode(goodsCode);
        if (goodsCode.equals(findGoodesCode)) {
            Toast.makeText(this, "验证成功", Toast.LENGTH_SHORT).show();
        } else {
            tipDialog.showMsg(false, "物料不匹配");
            return;
        }
        stringList.add(zbGoodsCode.getText().toString().trim());

        //品名
        int index = scanInfo.indexOf("-", scanInfo.indexOf("-", scanInfo.indexOf("-") + 1) + 1) + 1;
        int endIndex = scanInfo.indexOf("|");
        String goodsName = scanInfo.substring(index, endIndex);
        Log.e("TAG", "scanInfo:" + goodsName);
        planView.setMaterialName(goodsName);
        zbGoodsName.setText(goodsName);
        //重量
        String format = decimalFormat.format(
                Double.parseDouble(scanInfo.substring(scanInfo.indexOf("|") + 1, scanInfo.indexOf("kg"))));
        double weight = Double.parseDouble(format);
        planView.setMaterialWeight(weight);
        planView.setWholeMaterial(scanInfo);
        planView.setState(1);

    }
}