package com.example.pulit.adapter;

import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.Color;
import android.os.Build;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.RequiresApi;
import androidx.recyclerview.widget.RecyclerView;

import com.example.pulit.R;
import com.example.pulit.entity.Item;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

/**
 * @author: wangh
 * @description:
 * @date: 2019/08/06-08:36
 */
public class ItemAdapter extends RecyclerView.Adapter<ItemAdapter.MyViewHolder> {


    private List<Item> list;
    private Context mContext;
    private LayoutInflater inflater;

    public void setList(List<Item> list) {
        this.list = list;
    }

    public ItemAdapter(Context mContext) {
        this.mContext = mContext;
        inflater = LayoutInflater.from(mContext);
    }

    //创建
    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = inflater.inflate(R.layout.item_layout, parent, false);
        return new MyViewHolder(view);
    }


    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, int position) {
        Item been = list.get(position);

        holder.code.setText(been.getMaterial_Code());
        holder.name.setText(been.getMaterialName());
        holder.number.setText(been.getSetWeight()+"");
        if (been.isState()){
            holder.state.setText("正确");
            holder.state.setTextColor(Color.GREEN);
        }else{
            holder.state.setText("未验证");
            holder.state.setTextColor(Color.RED);
        }

    }


    //没用
    @RequiresApi(api = Build.VERSION_CODES.N)
    @Override
    public int getItemCount() {
        return Optional.ofNullable(list).map(u -> list.size()).orElse(0);
    }





    //刷新
    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, int position, @NonNull List<Object> payloads) {
        super.onBindViewHolder(holder, position, payloads);
        if (payloads.isEmpty()) {
            onBindViewHolder(holder, position); //绑定数据
        } else {//刷新倒计时所在的View
            Log.e("test", "刷新倒计时所在的View");
        }
    }

    //如果要点击变色必须要写，用来固定view
    class MyViewHolder extends RecyclerView.ViewHolder {

        TextView state;
        TextView code;
        TextView name;
        TextView number;


        public MyViewHolder(View view) {
            super(view);
            state=view.findViewById(R.id.item_state);
            code=view.findViewById(R.id.item_code);
            name=view.findViewById(R.id.item_name);
            number=view.findViewById(R.id.item_weight);

        }
    }

    public interface ItemClikeLitener{
        public void onItemClick(int tag);
    }
}
