package com.example.pulit.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.example.pulit.R;
import com.example.pulit.entity.AxPlan;

import java.util.List;
import java.util.Optional;

/**
 * @author wanghao
 * @date 2023/11/3  10:59
 */
public class PlanAdapter extends RecyclerView.Adapter<PlanAdapter.vm> {
    private Context context;
    private List<AxPlan> list;

    public PlanAdapter(Context context) {
        this.context = context;
    }

    public void setList(List<AxPlan> list) {
        this.list = list;
    }

    @Override
    public vm onCreateViewHolder(ViewGroup parent, int viewType) {
        View inflate = LayoutInflater.from(context).inflate(R.layout.item_plan, parent, false);
        return new vm(inflate);
    }

    @Override
    public void onBindViewHolder(PlanAdapter.vm holder, int position) {
        AxPlan axPlan = list.get(position);
        holder.index.setText(String.valueOf(position + 1));
        holder.planID.setText(axPlan.getPlan_Id());
        holder.planState.setText(axPlan.getPlan_StateText());
    }

    @Override
    @NonNull
    public int getItemCount() {
        return Optional.ofNullable(list).map(List::size).orElse(0);
    }

    public class vm extends RecyclerView.ViewHolder {
        private TextView index, planID, planState;

        public vm(View view) {
            super(view);
            index = view.findViewById(R.id.item_plan_index);
            planID = view.findViewById(R.id.item_plan_id);
            planState = view.findViewById(R.id.item_plan_state);
        }
    }
}
