package com.example.pulit.dialog;

import android.app.Dialog;
import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;

import com.example.pulit.R;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;


/**
 * @author: wangh
 * @description:
 * @date: 2019-11-05 17:21
 */
public class TipDialog extends Dialog {


    @BindView(R.id.tip1_state)
    ImageView tip1State;
    @BindView(R.id.tip1_info)
    TextView tip1Info;

    public TipDialog(@NonNull Context context) {
        super(context, R.style.CustomDialog);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.dialog_layout);
        ButterKnife.bind(this);
        setCanceledOnTouchOutside(false);
    }

    @OnClick(R.id.tip1_button)
    public void onClick() {
        dismiss();
    }


    public void showState(boolean state) {
        super.show();
        tip1State.setImageResource(state ? R.mipmap.dialog_yes : R.mipmap.dialog_jingg);
        tip1Info.setText(state ? "匹配成功" : "匹配失败");

    }

    public void showMsg(boolean state, String msg) {
        super.show();
        tip1State.setImageResource(state ? R.mipmap.dialog_yes : R.mipmap.dialog_jingg);
        tip1Info.setText(msg);

    }


}
